org.optaplanner.core.impl.heuristic.move

## Class CompositeMove<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.move.CompositeMove<Solution_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
  All Implemented Interfaces:
    Move<Solution_>

      public class CompositeMove<Solution_>
      extends Object
      implements Move<Solution_>

  A CompositeMove is composed out of multiple other moves.

  Warning: each of moves in the moveList must not rely on the effect of a previous move in the moveList to create its undoMove correctly.

  See Also:
    `Move`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Move<Solution_>[]` | `moves`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CompositeMove(Move<Solution_>... moves)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <Solution_,Move_ extends Move<Solution_>> Move<Solution_>` | `buildMove(List<Move_> moveList)`
    `static <Solution_,Move_ extends Move<Solution_>> Move<Solution_>` | `buildMove(Move_... moves)`
    `CompositeMove<Solution_>` | `doMove(ScoreDirector<Solution_> scoreDirector)` Does the move (which indirectly affects the `ScoreDirector.getWorkingSolution()`).
    `boolean` | `equals(Object o)`
    `Move<Solution_>[]` | `getMoves()`
    `Collection<? extends Object>` | `getPlanningEntities()` Returns all planning entities that are being changed by this move.
    `Collection<? extends Object>` | `getPlanningValues()` Returns all planning values that entities are being assigned to by this move.
    `String` | `getSimpleMoveTypeDescription()` Describes the move type for statistical purposes.
    `int` | `hashCode()`
    `boolean` | `isMoveDoable(ScoreDirector<Solution_> scoreDirector)` Called before a move is evaluated to decide whether the move can be done and evaluated.
    `CompositeMove<Solution_>` | `rebase(ScoreDirector<Solution_> destinationScoreDirector)` Rebases a move from an origin `ScoreDirector` to another destination `ScoreDirector` which is usually on another `Thread` or JVM.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### moves

          protected final Move<Solution_>[] moves

  - ### Constructor Detail

    - #### CompositeMove

          @SafeVarargs
          public CompositeMove(Move<Solution_>... moves)

      Parameters:
        `moves` - never null, never empty. Do not modify this argument afterwards or this CompositeMove corrupts.

  - ### Method Detail

    - #### buildMove

          @SafeVarargs
          public static <Solution_,Move_ extends Move<Solution_>> Move<Solution_> buildMove(Move_... moves)

      Parameters:
        `moves` - never null, sometimes empty. Do not modify this argument afterwards or the CompositeMove corrupts.
      Returns:
        never null

    - #### buildMove

          public static <Solution_,Move_ extends Move<Solution_>> Move<Solution_> buildMove(List<Move_> moveList)

      Parameters:
        `moveList` - never null, sometimes empty
      Returns:
        never null

    - #### getMoves

          public Move<Solution_>[] getMoves()

    - #### isMoveDoable

          public boolean isMoveDoable(ScoreDirector<Solution_> scoreDirector)

      Description copied from interface: `Move`
      Called before a move is evaluated to decide whether the move can be done and evaluated. A Move is not doable if:
      - Either doing it would change nothing in the `PlanningSolution`.
      - Either it's simply not possible to do (for example due to built-in hard constraints).

      It is recommended to keep this method implementation simple: do not use it in an attempt to satisfy normal hard and soft constraints.

      Although you could also filter out non-doable moves in for example the `MoveSelector` or `MoveListFactory`, this is not needed as the `Solver` will do it for you.

      Specified by:
        `isMoveDoable` in interface `Move<Solution_>`
      Parameters:
        `scoreDirector` - the `ScoreDirector` not yet modified by the move.
      Returns:
        true if the move achieves a change in the solution and the move is possible to do on the solution.

    - #### doMove

          public CompositeMove<Solution_> doMove(ScoreDirector<Solution_> scoreDirector)

      Description copied from interface: `Move`
      Does the move (which indirectly affects the `ScoreDirector.getWorkingSolution()`). When the `working solution` is modified, the `ScoreDirector` must be correctly notified (through `ScoreDirector.beforeVariableChanged(Object, String)` and `ScoreDirector.afterVariableChanged(Object, String)`), otherwise later calculated `Score`s will be corrupted.

      This method must end with calling `ScoreDirector.triggerVariableListeners()` to ensure all shadow variables are updated.

      This method must return an undo move, so the move can be evaluated and then be undone without resulting into a permanent change in the solution.

      Specified by:
        `doMove` in interface `Move<Solution_>`
      Parameters:
        `scoreDirector` - never null, the `ScoreDirector` that needs to get notified of the changes
      Returns:
        an undoMove which does the exact opposite of this move

    - #### rebase

          public CompositeMove<Solution_> rebase(ScoreDirector<Solution_> destinationScoreDirector)

      Description copied from interface: `Move`
      Rebases a move from an origin `ScoreDirector` to another destination `ScoreDirector` which is usually on another `Thread` or JVM. The new move returned by this method translates the entities and problem facts to the destination `PlanningSolution` of the destination `ScoreDirector`, That destination `PlanningSolution` is a deep planning clone (or an even deeper clone) of the origin `PlanningSolution` that this move has been generated from.

      That new move does the exact same change as this move, resulting in the same `PlanningSolution` state, presuming that destination `PlanningSolution` was in the same state as the original `PlanningSolution` to begin with.

      Generally speaking, an implementation of this method iterates through every entity and fact instance in this move, translates each one to the destination `ScoreDirector` with `ScoreDirector.lookUpWorkingObject(Object)` and creates a new move instance of the same move type, using those translated instances.

      The destination `PlanningSolution` can be in a different state than the original `PlanningSolution`. So, rebasing can only depend on the identity of `planning entities` and planning facts, which is usually declared by a `PlanningId` on those classes. It must not depend on the state of the `planning variables`. One thread might rebase a move before, amid or after another thread does that same move instance.

      This method is thread-safe.

      Specified by:
        `rebase` in interface `Move<Solution_>`
      Parameters:
        `destinationScoreDirector` - never null, the `ScoreDirector.getWorkingSolution()` that the new move should change the planning entity instances of.
      Returns:
        never null, a new move that does the same change as this move on another solution instance

    - #### getSimpleMoveTypeDescription

          public String getSimpleMoveTypeDescription()

      Description copied from interface: `Move`
      Describes the move type for statistical purposes. For example "ChangeMove(Process.computer)".

      The format is not formalized. Never parse the `String` returned by this method.

      Specified by:
        `getSimpleMoveTypeDescription` in interface `Move<Solution_>`
      Returns:
        never null

    - #### getPlanningEntities

          public Collection<? extends Object> getPlanningEntities()

      Description copied from interface: `Move`
      Returns all planning entities that are being changed by this move. Required for `AcceptorType.ENTITY_TABU`.

      This method is only called after `Move.doMove(ScoreDirector)` (which might affect the return values).

      Duplicate entries in the returned `Collection` are best avoided. The returned `Collection` is recommended to be in a stable order. For example: use `List` or `LinkedHashSet`, but not `HashSet`.

      Specified by:
        `getPlanningEntities` in interface `Move<Solution_>`
      Returns:
        never null

    - #### getPlanningValues

          public Collection<? extends Object> getPlanningValues()

      Description copied from interface: `Move`
      Returns all planning values that entities are being assigned to by this move. Required for `AcceptorType.VALUE_TABU`.

      This method is only called after `Move.doMove(ScoreDirector)` (which might affect the return values).

      Duplicate entries in the returned `Collection` are best avoided. The returned `Collection` is recommended to be in a stable order. For example: use `List` or `LinkedHashSet`, but not `HashSet`.

      Specified by:
        `getPlanningValues` in interface `Move<Solution_>`
      Returns:
        never null

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2006–2020 JBoss by Red Hat. All rights reserved.